use std::hash::Hash;

use chumsky::error::Simple;
use token::Tok;

pub mod ast;
pub mod token;

/// Parser over Generic input
pub trait AnyParser<I, O>: chumsky::Parser<I, O, Error = Simple<I>>
where
	I: Clone + Hash + Eq,
{
}
impl<T, I, O> AnyParser<I, O> for T
where
	I: Clone + Hash + Eq,
	T: chumsky::Parser<I, O, Error = Simple<I>>,
{
}

pub type AstParseErr = Simple<Tok>;
/// Parser over Token Streams
pub trait AstParser<O: Clone>: AstParserNonClone<O> + Clone {}
impl<T, O> AstParser<O> for T
where
	T: AstParserNonClone<O> + Clone,
	O: Clone,
{
}

pub trait AstParserNonClone<O>: AnyParser<Tok, O> {}
impl<T, O> AstParserNonClone<O> for T where T: AnyParser<Tok, O> {}
